summaryrefslogtreecommitdiff
path: root/GEMV/dimes-hetsim-nmc.sh
diff options
context:
space:
mode:
authorBirte Kristina Friesel <birte.friesel@uos.de>2024-07-23 16:58:27 +0200
committerBirte Kristina Friesel <birte.friesel@uos.de>2024-07-23 16:58:27 +0200
commit569709f82e52078f14cf05961565a58aee7893be (patch)
tree552ef6df983854cec141b05c534284e27f09e3b7 /GEMV/dimes-hetsim-nmc.sh
parent51f6e35ad52a9a070d57fd2b523faa68b5fba23b (diff)
GEMV: specify memcpy cpu node
Diffstat (limited to 'GEMV/dimes-hetsim-nmc.sh')
-rwxr-xr-xGEMV/dimes-hetsim-nmc.sh61
1 files changed, 36 insertions, 25 deletions
diff --git a/GEMV/dimes-hetsim-nmc.sh b/GEMV/dimes-hetsim-nmc.sh
index ed01cdc..416665d 100755
--- a/GEMV/dimes-hetsim-nmc.sh
+++ b/GEMV/dimes-hetsim-nmc.sh
@@ -1,7 +1,7 @@
#!/bin/bash
mkdir -p log/$(hostname) baselines/cpu/log/$(hostname)
-fn=log/$(hostname)/$(date +%Y%m%d)
+fn=log/$(hostname)/dimes-hetsim-nmc
# upstream DPU version uses -m 163840 -n 4096
# → (163840 * 4096 + 4096) * uint32 ≈ 2.5 GiB
@@ -10,23 +10,22 @@ fn=log/$(hostname)/$(date +%Y%m%d)
# → ≈ 1.25 GiB
# Note: Upstream uses int32_t in DPU version and double in baseline.
-# Here, we use int32_t for both.
+# Here, we use (163840 * 4096 + 4096 ) * int32_t for both.
run_benchmark_nmc() {
local "$@"
+ set -e
sudo limit_ranks_to_numa_node ${numa_rank}
- if make -B NR_DPUS=${nr_dpus} NR_TASKLETS=${nr_tasklets} WITH_ALLOC_OVERHEAD=1 WITH_LOAD_OVERHEAD=1 WITH_FREE_OVERHEAD=1; then
- bin/gemv_host -w 0 -e 100 -m 163840 -n 4096
- fi
- return $?
+ make -B NR_DPUS=${nr_dpus} NR_TASKLETS=${nr_tasklets} WITH_ALLOC_OVERHEAD=1 WITH_LOAD_OVERHEAD=1 WITH_FREE_OVERHEAD=1
+ bin/gemv_host -w 0 -e 100 -m 163840 -n 4096
}
export -f run_benchmark_nmc
run_benchmark_baseline() {
local "$@"
- OMP_NUM_THREADS=$nr_threads ./gemv $ram $ram $cpu
- return $?
+ set -e
+ OMP_NUM_THREADS=$nr_threads ./gemv $ram_in $ram_out $cpu $ram_local $cpu_memcpy
}
export -f run_benchmark_baseline
@@ -35,43 +34,55 @@ export -f run_benchmark_baseline
echo "NMC single-node (1/2)" >&2
-parallel -j1 --eta --joblog ${fn}.1.joblog --header : \
+parallel -j1 --eta --joblog ${fn}.1.joblog --resume --header : \
run_benchmark_nmc nr_dpus={nr_dpus} nr_tasklets=16 numa_rank={numa_rank} \
::: numa_rank 0 1 \
::: nr_dpus 64 128 256 512 768 1024
echo "NMC multi-node (2/2)" >&2
-parallel -j1 --eta --joblog ${fn}.2.joblog --header : \
+parallel -j1 --eta --joblog ${fn}.2.joblog --resume --header : \
run_benchmark_nmc nr_dpus={nr_dpus} nr_tasklets=16 numa_rank={numa_rank} \
::: numa_rank -1 \
::: nr_dpus 1536 2048 2304
-) > ${fn}.txt
-
-xz -f -v -9 -M 800M ${fn}.txt
+) >> ${fn}.txt
cd baselines/cpu
-make -B NUMA=1 TYPE=int32_t
(
-echo "CPU single-node (1/2)" >&2
+make -B NUMA=1 TYPE=int32_t NUMA_MEMCPY=1
+
+echo "CPU single-node operation with setup cost, memcpy/in and cpu/out on same node (1/3)" >&2
+
+parallel -j1 --eta --joblog ${fn}.1.joblog --resume --header : \
+ run_benchmark_baseline nr_threads={nr_threads} ram_in={ram_in} ram_out={ram_out} cpu={cpu} ram_local={ram_local} cpu_memcpy={cpu_memcpy} \
+ ::: ram_in 0 1 \
+ :::+ cpu_memcpy 0 1 \
+ ::: cpu 0 1 \
+ :::+ ram_out 0 1 \
+ :::+ ram_local 0 1 \
+ ::: nr_threads 1 2 4 8 12 16
-parallel -j1 --eta --joblog ${fn}.1.joblog --header : \
- run_benchmark_baseline nr_threads={nr_threads} ram={ram} cpu={cpu} \
+make -B NUMA=1 TYPE=int32_t
+
+echo "CPU single-node (2/3)" >&2
+
+parallel -j1 --eta --joblog ${fn}.2.joblog --resume --header : \
+ run_benchmark_baseline nr_threads={nr_threads} ram_in={ram_in} ram_out={ram_out} cpu={cpu} \
::: cpu 0 1 \
- ::: ram 0 1 \
+ ::: ram_in 0 1 \
+ ::: ram_out 0 1 \
::: nr_threads 1 2 4 8 12 16
-echo "CPU multi-node (2/2)" >&2
+echo "CPU multi-node (3/3)" >&2
-parallel -j1 --eta --joblog ${fn}.2.joblog --header : \
- run_benchmark_baseline nr_threads={nr_threads} ram={ram} cpu={cpu} \
+parallel -j1 --eta --joblog ${fn}.3.joblog --resume --header : \
+ run_benchmark_baseline nr_threads={nr_threads} ram_in={ram_in} ram_out={ram_out} cpu={cpu} \
::: cpu -1 \
- ::: ram 0 1 \
+ ::: ram_in 0 1 \
+ ::: ram_out 0 1 \
::: nr_threads 24 32
-) > ${fn}.txt
-
-xz -f -v -9 -M 800M ${fn}.txt
+) >> ${fn}.txt